-- name: Kapi's RnR's Moveset
-- description: This mod lets you play with the moveset of Kapi in the roblox game "Kapi's Rock n' Roll"!

local ACT_FLAG_CAN_DASH = 1

local ACT_FLAG_CAN_ROLL_VARIATE = 1

local function mario_update(m)
  if m.playerIndex == 0 then
  
  if m.action ==
  ACT_WALKING or m.action ==
  ACT_IDLE or m.action ==
  ACT_KAPI_JUMP or m.action ==
  ACT_PANTING or m.action ==
  ACT_PUNCHING or m.action ==
  ACT_DIVE or m.action ==
  ACT_JUMP_KICK or m.action ==
  ACT_MOVE_PUNCHING or m.action ==
  ACT_DIVE_SLIDE or m.action ==
  ACT_SLIDE_KICK or m.action ==
  ACT_FREEFALL or m.action & ACT_FLAG_BUTT_OR_STOMACH_SLIDE ~= 0  and m.action ~= ACT_KAPI_ROLL then 
    if m.controller.buttonDown & B_BUTTON ~= 0 then
      if m.action & ACT_FLAG_AIR == 0 then
    set_mario_action(m, ACT_KAPI_ROLL, 0) 
    end
    end
end

if (m.action == ACT_KAPI_JUMP or
m.action == ACT_KAPI_DASH or
m.action == ACT_WALL_KICK_AIR or 
m.action == ACT_JUMP_LAND or
m.action == ACT_KAPI_AIRJUMP) and m.actionTimer > 5 or
m.action == ACT_KAPI_FREEFALL or
m.action == ACT_KAPI_DASH_CANCEL then
if m.action & ACT_FLAG_AIR ~= 0 then
  if m.controller.buttonDown & B_BUTTON ~= 0 and m.action ~= ACT_KAPI_ROLL_AIR then
    set_mario_action(m, ACT_KAPI_ROLL_AIR, 0)
end
end
end

if (m.action == ACT_KAPI_JUMP or (m.action == ACT_KAPI_HIGH_JUMP and m.actionTimer > 4) or m.action == ACT_WALL_KICK_AIR) and m.vel.y < -1 then set_mario_action(m, ACT_KAPI_FREEFALL, 0)
  end

if m.action == ACT_KAPI_JUMP or
m.action == ACT_KAPI_LONG_JUMP or
m.action == ACT_KAPI_HIGH_JUMP or
m.action == ACT_WALL_KICK_AIR or
m.action == ACT_KAPI_DASH_CANCEL or
m.action == ACT_KAPI_AIR_JUMP or
m.action == ACT_KAPI_FREEFALL then
if m.action & ACT_FLAG_AIR ~= 0 then
  if m.controller.buttonPressed & A_BUTTON ~= 0 and m.action ~= ACT_KAPI_TWIRL then
    if m.actionTimer > 5 then
    set_mario_action(m, ACT_KAPI_TWIRL, 0)
    if m.prevAction == ACT_KAPI_AIR_JUMP then
      ACT_FLAG_CAN_ROLL_VARIATE = 0
      end
    end
  end
end
end
  
  if m.action ==
  ACT_KAPI_JUMP or m.action ==
  ACT_WALL_KICK_AIR or m.action == ACT_KAPI_HIGH_JUMP or m.action == ACT_KAPI_LONG_JUMP or m.action == ACT_SOFT_BONK or m.action == ACT_KAPI_AIR_JUMP or m.action == ACT_KAPI_FREEFALL then
    if m.controller.buttonPressed & X_BUTTON ~= 0 and ACT_FLAG_CAN_DASH ~= 0 then
      set_mario_action(m, ACT_KAPI_DASH, 0)
      ACT_FLAG_CAN_DASH = 0
    end
  end
  
  if m.action == ACT_KAPI_ROLL then
    if m.controller.buttonPressed & A_BUTTON ~= 0 and m.controller.stickMag == 0 then
      set_mario_action(m, ACT_KAPI_HIGH_JUMP, 0)
      m.forwardVel = 0
      m.vel.y = 65
    elseif m.controller.buttonPressed & A_BUTTON ~= 0 and m.controller.stickMag > 0 then
      set_mario_action(m, ACT_KAPI_LONG_JUMP, 0)
      m.forwardVel = 50
      m.vel.y = 55
      end
    end
  
  if m.action == ACT_KAPI_ROLL_AIR then
    if m.controller.buttonPressed & A_BUTTON ~= 0 and ACT_FLAG_CAN_ROLL_VARIATE ~= 0 then
      set_mario_action(m, ACT_KAPI_AIR_JUMP, 0)
      ACT_FLAG_CAN_ROLL_VARIATE = 0
      m.forwardVel = m.forwardVel / 8
      m.vel.y = 65
  end
  end

  if m.wall and m.action & ACT_FLAG_AIR ~= 0 and (m.action ~= ACT_KAPI_ROLL or m.action ~= ACT_GROUND_BONK) then
                set_mario_action(m, ACT_KAPI_WALL, 0)
  end
  
  m.peakHeight = m.pos.y
          
end
end

local function on_set_mario_action(m)
  
  if m.playerIndex == 0 then
    
  if m.action == ACT_KAPI_ROLL_AIR and m.controller.buttonPressed & A_BUTTON ~= 0 then
    if m.action & ACT_FLAG_AIR ~= 0 then
      ACT_FLAG_CAN_ROLL_VARIATE = 0
    end
  end
  
  if m.action == ACT_GROUND_BONK then
      m.vel.y = 20
    m.forwardVel = -35
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
      end
  
  if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_LONG_JUMP or m.action == ACT_SIDE_FLIP or m.action == ACT_STEEP_JUMP or m.action == ACT_BACK_FLIP or m.action == ACT_WATER_JUMP then
      set_mario_action(m, ACT_KAPI_JUMP, 0)
  end
  
  if m.action == ACT_FREEFALL or m.action == ACT_GROUND_POUND then
    set_mario_action(m, ACT_KAPI_FREEFALL, 0)
    end
  
  if m.action == ACT_DIVE then
    set_mario_action(m, ACT_KAPI_ROLL, 0)
    end
  
  if m.action == ACT_WALKING then
    m.faceAngle.y = m.intendedYaw
  end
  
  if m.action & ACT_FLAG_AIR == 0 or m.action == ACT_KAPI_WALL then
     ACT_FLAG_CAN_DASH = 1
  end
  if m.action & ACT_FLAG_AIR == 0 then
    ACT_FLAG_CAN_ROLL_VARIATE = 1
    end
   
  end
  end

  hook_event(HOOK_MARIO_UPDATE, mario_update)
  hook_event(HOOK_ON_SET_MARIO_ACTION, on_set_mario_action)